"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
const core_1 = require("@babel/core");
const types = __importStar(require("@babel/types"));
const DEBUGGER_LITERAL = 'debugger';
const DEBUG_ASYNC_FUNCTION = '__debugAsync__';
const IMPORT_DEBUG_ASYNC_LINE_DEFAULT = (`const {debugAsync: ${DEBUG_ASYNC_FUNCTION}} = require('async-debugger');`);
function addPauseToDebugRequire(path, importDebugAsyncLine) {
    const result = core_1.parseSync(importDebugAsyncLine);
    if (result === null) {
        return;
    }
    const { body } = types.isFile(result) ? result.program : result;
    path.unshiftContainer('body', body);
}
function handleAwaitDebuggerExpression(path) {
    let variableNames = [];
    path.find((parent) => {
        if (parent.isScopable()) {
            variableNames = [...variableNames, ...Object.keys(parent.scope.bindings)];
        }
        return false;
    });
    const set = new Set(variableNames);
    const requiresPauseToDebug = !set.has(DEBUG_ASYNC_FUNCTION);
    variableNames = [...set];
    path.replaceWith(types.sequenceExpression([
        types.awaitExpression(types.callExpression(types.identifier(DEBUG_ASYNC_FUNCTION), [
            types.objectExpression(variableNames.map((name) => (types.objectProperty(types.identifier(name), types.arrowFunctionExpression([], types.identifier(name))))))
        ])),
        path.node
    ]));
    return requiresPauseToDebug;
}
module.exports = (_api, { importDebugAsyncLine = IMPORT_DEBUG_ASYNC_LINE_DEFAULT } = {}) => {
    const awaitDebuggerExpressions = new Set();
    return {
        visitor: {
            StringLiteral(path) {
                if (path.node.value === DEBUGGER_LITERAL &&
                    path.parentPath.isAwaitExpression()) {
                    awaitDebuggerExpressions.add(path.parentPath);
                }
            }
        },
        post(file) {
            let requiresPauseToDebug = false;
            for (const path of awaitDebuggerExpressions) {
                if (handleAwaitDebuggerExpression(path)) {
                    requiresPauseToDebug = true;
                }
            }
            if (requiresPauseToDebug) {
                addPauseToDebugRequire(file.path, importDebugAsyncLine);
            }
        }
    };
};
